src/Entity/Location.php
<?php

namespace App\Entity;

use App\Repository\LocationRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=LocationRepository::class)
 */
class Location
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="date")
     */
    private $date_debut;

    /**
     * @ORM\Column(type="date")
     */
    private $date_retour;

    /**
     * @ORM\Column(type="float")
     */
    private $prix;

    /**
     * @ORM\ManyToOne(targetEntity=Voiture::class, inversedBy="location")
     */
    private $voiture;

    /**
     * @ORM\ManyToOne(targetEntity=Client::class, inversedBy="loc")
     */
    private $client;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getDateDebut(): ?\DateTimeInterface
    {
        return $this->date_debut;
    }

    public function setDateDebut(\DateTimeInterface $date_debut): self
    {
        $this->date_debut = $date_debut;

        return $this;
    }

    public function getDateRetour(): ?\DateTimeInterface
    {
        return $this->date_retour;
    }

    public function setDateRetour(\DateTimeInterface $date_retour): self
    {
        $this->date_retour = $date_retour;

        return $this;
    }

    public function getPrix(): ?float
    {
        return $this->prix;
    }

    public function setPrix(float $prix): self
    {
        $this->prix = $prix;

        return $this;
    }

    public function getVoiture(): ?Voiture
    {
        return $this->voiture;
    }

    public function setVoiture(?Voiture $voiture): self
    {
        $this->voiture = $voiture;

        return $this;
    }

    public function getClient(): ?Client
    {
        return $this->client;
    }

    public function setClient(?Client $client): self
    {
        $this->client = $client;

        return $this;
    }
}

src/Form/LocationType.php
<?php

namespace App\Form;

use App\Entity\Location;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class LocationType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('date_debut')
            ->add('date_retour')
            ->add('prix')
            ->add('voiture')
            ->add('client')
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Location::class,
        ]);
    }
}

src/Controller/LocationController.php
<?php

namespace App\Controller;

use App\Entity\Location;
use App\Form\LocationType;
use App\Repository\LocationRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/location")
 */
class LocationController extends AbstractController
{
    /**
     * @Route("/", name="app_location_index", methods={"GET"})
     */
    public function index(LocationRepository $locationRepository): Response
    {
        return $this->render('location/index.html.twig', [
            'locations' => $locationRepository->findAll(),
        ]);
    }

    /**
     * @Route("/new", name="app_location_new", methods={"GET", "POST"})
     */
    public function new(Request $request, LocationRepository $locationRepository): Response
    {
        $location = new Location();
        $form = $this->createForm(LocationType::class, $location);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $locationRepository->add($location, true);

            return $this->redirectToRoute('app_location_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('location/new.html.twig', [
            'location' => $location,
            'form' => $form,
        ]);
    }

    /**
     * @Route("/{id}", name="app_location_show", methods={"GET"})
     */
    public function show(Location $location): Response
    {
        return $this->render('location/show.html.twig', [
            'location' => $location,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="app_location_edit", methods={"GET", "POST"})
     */
    public function edit(Request $request, Location $location, LocationRepository $locationRepository): Response
    {
        $form = $this->createForm(LocationType::class, $location);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $locationRepository->add($location, true);

            return $this->redirectToRoute('app_location_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('location/edit.html.twig', [
            'location' => $location,
            'form' => $form,
        ]);
    }

    /**
     * @Route("/{id}", name="app_location_delete", methods={"POST"})
     */
    public function delete(Request $request, Location $location, LocationRepository $locationRepository): Response
    {
        if ($this->isCsrfTokenValid('delete' . $location->getId(), $request->request->get('_token'))) {
            $locationRepository->remove($location, true);
        }

        return $this->redirectToRoute('app_location_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/location/_delete_form.html.twig
<form method="post" action="{{ path('app_location_delete', {'id': location.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ location.id) }}">
    <button class="btn">Delete</button>
</form>

templates/location/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/location/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Location{% endblock %}

{% block body %}
    <h1>Edit Location</h1>

    {{ include('location/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('app_location_index') }}">back to list</a>

    {{ include('location/_delete_form.html.twig') }}
{% endblock %}

templates/location/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Location index{% endblock %}

{% block body %}
    <h1>Location index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Date_debut</th>
                <th>Date_retour</th>
                <th>Prix</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for location in locations %}
            <tr>
                <td>{{ location.id }}</td>
                <td>{{ location.dateDebut ? location.dateDebut|date('Y-m-d') : '' }}</td>
                <td>{{ location.dateRetour ? location.dateRetour|date('Y-m-d') : '' }}</td>
                <td>{{ location.prix }}</td>
                <td>
                    <a href="{{ path('app_location_show', {'id': location.id}) }}">show</a>
                    <a href="{{ path('app_location_edit', {'id': location.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="5">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('app_location_new') }}">Create new</a>
{% endblock %}

templates/location/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Location{% endblock %}

{% block body %}
    <h1>Create new Location</h1>

    {{ include('location/_form.html.twig') }}

    <a href="{{ path('app_location_index') }}">back to list</a>
{% endblock %}

templates/location/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Location{% endblock %}

{% block body %}
    <h1>Location</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ location.id }}</td>
            </tr>
            <tr>
                <th>Date_debut</th>
                <td>{{ location.dateDebut ? location.dateDebut|date('Y-m-d') : '' }}</td>
            </tr>
            <tr>
                <th>Date_retour</th>
                <td>{{ location.dateRetour ? location.dateRetour|date('Y-m-d') : '' }}</td>
            </tr>
            <tr>
                <th>Prix</th>
                <td>{{ location.prix }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('app_location_index') }}">back to list</a>

    <a href="{{ path('app_location_edit', {'id': location.id}) }}">edit</a>

    {{ include('location/_delete_form.html.twig') }}
{% endblock %}